<?php

use WHMCS\Database\Capsule;

add_hook('ClientAreaProductDetailsOutput', 1, function($vars) {
    $userid = $vars['service']['userid'];
    $serviceid = $vars['service']['id'];
    $clientId = $_SESSION['uid'];

    $service = Capsule::table('tblhosting')
        ->where('id', $serviceid)
        ->where('userid', $clientId)
        ->first();

    if ($service) {
        $server = Capsule::table('tblservers')
            ->where('id', $service->server)
            ->first();

        $username = $service->username;
        $password = decrypt($service->password);
        $domain = $service->domain;
        $serverIp = $server->ipaddress;
        $serverHostname = $server->hostname;
        $name1 = $server->nameserver1 ?: 'N/A';
        $name2 = $server->nameserver2 ?: 'N/A';

        $output = '
        <style>
            .details-row {
                background-color: #f0f8f0;
                border-radius: 5px;
                padding: 10px;
                margin-bottom: 10px;
            }
            .label {
                background-color: #444;
                color: white;
                padding: 5px 10px;
                border-radius: 5px;
            }
            .value {
                background-color: #eaf5ea;
                padding: 5px 10px;
                border-radius: 5px;
            }
            .password-field {
                display: inline-block;
            }
            .password-icon {
                cursor: pointer;
            }
        </style>

        <div class="panel panel-default">
            <div class="panel-heading">
                <h3 class="panel-title"><i class="fas fa-server"></i> Hosting Account Details</h3>
            </div>
            <div class="card-body">
                <div class="row">';

                $output .= '<div class="col-md-6">
                        <div class="details-row">
                            <span class="label">Domain</span>
                            <span class="value">' . $domain . '</span>
                        </div>
                        <div class="details-row">
                            <span class="label">Username</span>
                            <span class="value">' . $username . '</span>
                        </div>
                        <div class="details-row">
                            <span class="label">Password</span>
                            <span id="password" class="value" style="display:none;">' . $password . '</span>
                            <span id="password-mask" class="value">'.substr_replace($password, str_repeat('*', strlen($password)), 0, strlen($password)).'</span>
                            <span id="toggle-password" class="value"><i class="fas fa-eye"></i></span>
                        </div>
                        <div class="details-row">
                            <span class="label">IP Address</span>
                            <span class="value">' . $serverIp . '</span>
                        </div>
                    </div>

                    <div class="col-md-6">
                        <div class="details-row">
                            <span class="label">Hostname</span>
                            <span class="value">' . $serverHostname . '</span>
                        </div>
                        <div class="details-row">
                            <span class="label">Nameserver 1</span>
                            <span class="value">' . $name1 . '</span>
                        </div>
                        <div class="details-row">
                            <span class="label">Nameserver 2</span>
                            <span class="value">' . $name2 . '</span>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <script>
            document.getElementById("toggle-password").addEventListener("click", function() {
                var passwordField = document.getElementById("password");
                var passwordMask = document.getElementById("password-mask");
                var toggleIcon = this.querySelector("i");

                if (passwordField.style.display === "none") {
                    passwordField.style.display = "inline";
                    passwordMask.style.display = "none";
                    toggleIcon.classList.remove("fa-eye");
                    toggleIcon.classList.add("fa-eye-slash");
                } else {
                    passwordField.style.display = "none";
                    passwordMask.style.display = "inline";
                    toggleIcon.classList.remove("fa-eye-slash");
                    toggleIcon.classList.add("fa-eye");
                }
            });

            document.getElementById("password").addEventListener("click", function() {
                navigator.clipboard.writeText(this.textContent).then(function() {
                    alert("Password copied to clipboard.");
                }).catch(function() {
                    alert("Failed to copy the password.");
                });
            });
        </script>';
        
        return $output;
    }

    return '';
});
